﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;

using Demo;

namespace Demo
{    
    class Program
    {
        static void Main(string[] args)
        {
            LLPRAPI.Callback cb = new LLPRAPI.Callback(demoCallback);
            if (LLPRAPI.initClientApi("192.168.1.20", "192.168.1.102", 20790, cb) != API_STATUS.OK) {
                Console.WriteLine("initialize API failure!");
                return;
            }
            else
            {
                Console.WriteLine("initialize API success!");
            }


            Thread.Sleep(300 * 1000);
            // can close api in another thread
            Console.WriteLine("prepare to exit...");
            LLPRAPI.closeClientApi();
        }

        public static void demoCallback(ref PlateBasicInfo pbi)
        {
            Console.WriteLine("plate No: {0} at [{1}, {2}, {3}, {4}], {5}", pbi.plateNos, pbi.bbox.xmin, pbi.bbox.ymin, pbi.bbox.xmax, pbi.bbox.ymax, pbi.plateNoBytes);
            if (pbi.imageBuffer == IntPtr.Zero)
            {
                return;
            }

            BinaryWriter writer = new BinaryWriter(new FileStream("test.jpg", FileMode.Create));
            byte[] buffer = new byte[pbi.imageBufferSize];
            System.Runtime.InteropServices.Marshal.Copy(pbi.imageBuffer, buffer, 0, pbi.imageBufferSize);
            writer.Write(buffer);
            writer.Close();
            Console.WriteLine("write plate image success!");
        }
    }
}
